scriptencoding utf-8

if !exists('autocommands_loaded') && has('autocmd')
    let autocommands_loaded = 1

    aug relativize
        au BufWinEnter,FocusGained,InsertLeave,WinEnter * call dead#functions#Relativize(1)
        au BufWinLeave,FocusLost,InsertEnter,WinLeave * call dead#functions#Relativize(0)
    aug END

    aug miscs
        au CursorHold * silent call CocActionAsync('highlight')
        au User CocJumpPlaceholder call CocActionAsync('showSignatureHelp')
        au ColorScheme * call dead#functions#MyHighlights()
    aug END

    aug inserts
        au InsertEnter * setlocal nocursorline
        au InsertLeave * setlocal cursorline nopaste
        au InsertLeave,CompleteDone * if pumvisible() == 0 | pclose | endif
        au FocusLost,TabLeave * call dead#functions#PopOutOfInsertMode()
        au WinLeave * setlocal nocursorline
    aug END

    aug file_types
        au BufNewFile ~/doc/blog/*.wiki 0r ~/.config/nvim/templates/wiki.skeleton
        au FileType typescript,json setlocal formatexpr=CocAction('formatSelected')
        au FileType gitcommit,gitrebase,gitconfig set bufhidden=delete
        au BufNewFile,BufRead requirements*.txt set syntax=python
    aug END

    aug statusline
        au VimEnter * call dead#statusline#UpdateInactiveWindows()
        au VimEnter,WinEnter,BufWinEnter * call dead#statusline#RefreshStatusLine('active')
        au WinLeave * call dead#statusline#RefreshStatusLine('inactive')
    augroup END

    aug on_save
        au BufWritePre * :%s/\s\+$//e
        au BufWritePost *xresources !xrdb %
        au BufWritePost *sxhkdrc !pkill -USR1 sxhkd
        au BufWritePost *.tex !pdflatex %
        au QuitPre * if empty(&buftype) | lclose | endif
    aug END
endif
